<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lab5</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
</head>
<body>
    <div class="w-100 d-flex justify-content-center">
        <table class="table w-75">
            <thead>
              <tr>
                <th scope="col">#</th>
                <th scope="col">To</th>
                <th scope="col">From</th>
                <th scope="col">Title</th>
                <th scope="col">Message</th>
                <th scope="col">Actions</th>
              </tr>
            </thead>
            <tbody>
                {% if notes %}
                    {% for note in notes %}
                        <tr>
                            <th scope="row">{{ forloop.counter }}</th>
                            <td>{{ note.note_to }}</td>
                            <td>{{ note.note_from }}</td>
                            <td>{{ note.title }}</td>
                            <td>{{ note.message }}</td>
                            <td>
                                <button type="button" class="btn btn-primary">View</button>
                                <button type="button" type="button" class="btn btn-secondary" data-bs-toggle="modal" data-bs-target="#exampleModal" data-to="{{ note.note_to }}" data-from="{{ note.note_from }}" data-title="{{ note.title }}" data-message="{{ note.message }}" data-pk="{{ note.pk }}">Edit</button>
                                <button type="button" pk={{ note.pk }} class="delete-note btn btn-danger">Delete</button>
                            </td>
                        </tr>
                    {% endfor %}
                {% endif %}
            </tbody>
        </table>

        <div class="modal fade" id="exampleModal" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="staticBackdropLabel">Edit</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="mb-3">
                        <label for="exampleFormControlInput1" class="form-label">To</label>
                        <input type="text" class="form-control to" id="modal_to" value="" placeholder="To">
                    </div>
                    <div class="mb-3">
                        <label for="exampleFormControlInput1" class="form-label">From</label>
                        <input type="text" class="form-control from" id="modal_from" value="" placeholder="From">
                    </div>
                    <div class="mb-3">
                        <label for="exampleFormControlInput1" class="form-label">Title</label>
                        <input type="text" class="form-control title" id="modal_title" value="" placeholder="Title">
                    </div>
                    <div class="mb-3">
                        <label for="exampleFormControlTextarea1" class="form-label">Message</label>
                        <textarea class="form-control message" id="modal_message" rows="3" value=""></textarea>
                    </div> 
                </div>
                <div class="modal-footer">
                    <button type="button" pk="" class="edit-note btn btn-primary">Save</button>
                </div>
                </div>
            </div>
        </div>

        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

        <script>
            var exampleModal = document.getElementById('exampleModal')
            exampleModal.addEventListener('show.bs.modal', function (event) {
                // Button that triggered the modal
                var button = event.relatedTarget
                // Extract info from data-* attributes
                var to = button.getAttribute('data-to')
                var from = button.getAttribute('data-from')
                var title = button.getAttribute('data-title')
                var message = button.getAttribute('data-message')
                var pk = button.getAttribute('data-pk')

                console.log(button.getAttribute('data-title'))

                // If necessary, you could initiate an AJAX request here
                // and then do the updating in a callback.
                
                // Get the modal's content.
                var modalBodyTo = exampleModal.querySelector('.modal-body .to')
                var modalBodyFrom = exampleModal.querySelector('.modal-body .from')
                var modalBodyTitle = exampleModal.querySelector('.modal-body .title')
                var modalBodyMessage = exampleModal.querySelector('.modal-body .message')
                var modalSaveButton = exampleModal.getElementsByClassName("edit-note")

                modalBodyTo.value = to
                modalBodyFrom.value = from
                modalBodyTitle.value = title
                modalBodyMessage.value = message
                modalSaveButton.pk = pk
            })

            function getCookie(cname) {
                let name = cname + "=";
                let decodedCookie = decodeURIComponent(document.cookie);
                let ca = decodedCookie.split(';');
                for(let i = 0; i <ca.length; i++) {
                    let c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            $(document).ready(function(){
                $(".edit-note").click(function() {
                    console.log("asu")
                    $.ajax({
                        url: "http://localhost:8000/lab-5/edit_note",
                        method: "POST",
                        headers: {
                            "X-CSRFToken": getCookie("csrftoken")
                        },
                        data: {
                            "id": exampleModal.getElementsByClassName("edit-note").pk,
                            "note_to": document.getElementById('modal_to').value,
                            "note_from": document.getElementById('modal_from').value,
                            "title": document.getElementById('modal_title').value,
                            "message": document.getElementById('modal_message').value,
                        },
                        success: function(result){
                            location.reload();
                        },
                        error: function (err) {
                            console.error(err)
                        }
                    })
                })

                $(".delete-note").click(function(){
                    $.ajax({
                        url: "http://localhost:8000/lab-5/delete_note",
                        method: "POST",
                        headers: {
                            "X-CSRFToken": getCookie("csrftoken")
                        },
                        data: {
                            "id": $(this).attr('pk')
                        },
                        success: function(result){
                            location.reload();
                        },
                        error: function (err) {
                            console.error(err)
                        }
                    });
                });
            });
        </script>
    </div>
</body>
</html>